OGRE: Ogre::ScreenRatioPixelCountLodStrategy Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::ScreenRatioPixelCountLodStrategy Class Reference

The ScreenRatioPixelCountLodStrategy class Implement a strategy which calculates LOD ratios based on coverage in screen ratios in the range [-1.0; 0.0] where -1.0 means the object is covering the whole screen and 0 covering almost nothing in the screen (very tiny). More...

`#include <OgrePixelCountLodStrategy.h>`

Inheritance diagram for Ogre::ScreenRatioPixelCountLodStrategy:
[legend]

## Public Member Functions
| ScreenRatioPixelCountLodStrategy ()
| Default constructor. More...
virtual Real | getBaseValue () const
| Get the value of the first (highest) level of detail. More...
const String & | getName () const
| Get the name of this strategy. More...
Real | getValue (const MovableObject *movableObject, const Camera *camera) const
| Compute the LOD value for a given movable object relative to a given camera. More...
Real | getValueImpl (const MovableObject *movableObject, const Camera *camera) const
virtual void | lodUpdateImpl (const size_t numNodes, ObjectData t, const Camera *camera, Real bias) const
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual Real | transformBias (Real factor) const
| Transform LOD bias so it only needs to be multiplied by the LOD value. More...
virtual Real | transformUserValue (Real userValue) const
| Transform user supplied value to internal value. More...

## Static Public Member Functions
static void | assertSorted (const v1::Mesh::LodValueArray &values)
| Assert that the LOD values are sorted from greatest detail to least detail. More...
static ushort | getIndex (Real value, const Material::LodValueArray &materialLodValueArray)
| Get the index of the LOD usage which applies to a given value. More...
static ushort | getIndex (Real value, const v1::Mesh::MeshLodUsageList &meshLodUsageList)
| Get the index of the LOD usage which applies to a given value. More...
static ScreenRatioPixelCountLodStrategy & | getSingleton (void)
| Override standard Singleton retrieval. More...
static ScreenRatioPixelCountLodStrategy * | getSingletonPtr (void)
| Override standard Singleton retrieval. More...
static bool | isSorted (const v1::Mesh::LodValueArray &values)
| Determine if the LOD values are sorted from greatest detail to least detail. More...
static void | lodSet (ObjectData &t, Real lodValues[ARRAY_PACKED_REALS])
static void | sort (v1::Mesh::MeshLodUsageList &meshLodUsageList)
| Sort mesh LOD usage list from greatest to least detail. More...

## Detailed Description

The ScreenRatioPixelCountLodStrategy class Implement a strategy which calculates LOD ratios based on coverage in screen ratios in the range [-1.0; 0.0] where -1.0 means the object is covering the whole screen and 0 covering almost nothing in the screen (very tiny).

Note however that:

1. Values beyond -1.0 are possible (it just means the object is bigger than the screen)
2. It's an approximation

## Constructor & Destructor Documentation

## ◆ ScreenRatioPixelCountLodStrategy()

Ogre::ScreenRatioPixelCountLodStrategy::ScreenRatioPixelCountLodStrategy | ( |  | ) |

Default constructor.

## Member Function Documentation

## ◆ assertSorted()

static void Ogre::LodStrategy::assertSorted | ( | const v1::Mesh::LodValueArray & | values | ) |
| staticinherited

Assert that the LOD values are sorted from greatest detail to least detail.

## ◆ getBaseValue()

virtual Real Ogre::PixelCountLodStrategyBase::getBaseValue | ( |  | ) | const
| virtualinherited

Get the value of the first (highest) level of detail.

Implements Ogre::LodStrategy.

## ◆ getIndex() [1/2]

static ushort Ogre::LodStrategy::getIndex | ( | Real | value,
|  | const Material::LodValueArray & | materialLodValueArray
| ) |  |
| staticinherited

Get the index of the LOD usage which applies to a given value.

## ◆ getIndex() [2/2]

static ushort Ogre::LodStrategy::getIndex | ( | Real | value,
|  | const v1::Mesh::MeshLodUsageList & | meshLodUsageList
| ) |  |
| staticinherited

Get the index of the LOD usage which applies to a given value.

## ◆ getName()

const String& Ogre::LodStrategy::getName | ( |  | ) | const
| inlineinherited

Get the name of this strategy.

## ◆ getSingleton()

static ScreenRatioPixelCountLodStrategy& Ogre::ScreenRatioPixelCountLodStrategy::getSingleton | ( | void |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getSingletonPtr()

static ScreenRatioPixelCountLodStrategy* Ogre::ScreenRatioPixelCountLodStrategy::getSingletonPtr | ( | void |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getValue()

Real Ogre::LodStrategy::getValue | ( | const MovableObject * | movableObject,
|  | const Camera * | camera
| ) |  | const
| inherited

Compute the LOD value for a given movable object relative to a given camera.

## ◆ getValueImpl()

Real Ogre::ScreenRatioPixelCountLodStrategy::getValueImpl | ( | const MovableObject * | movableObject,
|  | const Camera * | camera
| ) |  | const
| virtual

Implements Ogre::LodStrategy.

## ◆ isSorted()

static bool Ogre::LodStrategy::isSorted | ( | const v1::Mesh::LodValueArray & | values | ) |
| staticinherited

Determine if the LOD values are sorted from greatest detail to least detail.

## ◆ lodSet()

static void Ogre::LodStrategy::lodSet | ( | ObjectData & | t,
|  | Real | lodValues[ARRAY_PACKED_REALS]
| ) |  |
| inlinestaticinherited

## ◆ lodUpdateImpl()

virtual void Ogre::ScreenRatioPixelCountLodStrategy::lodUpdateImpl | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const Camera * | camera,
|  | Real | bias
| ) |  | const
| virtual

Implements Ogre::LodStrategy.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ sort()

static void Ogre::LodStrategy::sort | ( | v1::Mesh::MeshLodUsageList & | meshLodUsageList | ) |
| staticinherited

Sort mesh LOD usage list from greatest to least detail.

## ◆ transformBias()

virtual Real Ogre::PixelCountLodStrategyBase::transformBias | ( | Real | factor | ) | const
| virtualinherited

Transform LOD bias so it only needs to be multiplied by the LOD value.

Implements Ogre::LodStrategy.

## ◆ transformUserValue()

virtual Real Ogre::PixelCountLodStrategyBase::transformUserValue | ( | Real | userValue | ) | const
| inlinevirtualinherited

Transform user supplied value to internal value.

Remarks
  Do not throw exceptions for invalid values here, as the LOD strategy may be changed such that the values become valid.

Reimplemented from Ogre::LodStrategy.

The documentation for this class was generated from the following file:

- OgrePixelCountLodStrategy.h